info = {
    'icon' : 'EVENT_X',
    'description' : 'Delete all blend backup version (.blend1 and next backups) in passed directory',
    'folderpath' : '',
    'recursive' : True,
    'test' : False,
}

# coding: utf-8
import bpy
import os
import re, fnmatch, glob
from pathlib import Path
import shutil
C = bpy.context
D = bpy.data
scene = C.scene


def kill_blend_backup_version(fp, recursive=True, test=False):
    if not fp:
        print('ERROR', 'no filepath given')
        return
    
    re_blendbackup = re.compile(r'\.blend\d+')
    fpo = Path(fp)

    if not fpo.exists():
        print('ERROR', f'invalid path: {fp}')
        return
    
    ct = 0
    print(f'Removing blend backup files in : {fpo}')
    if recursive:
        for root, dirs, files in os.walk(fp):
            for name in files:
                fo = Path(root) / name
                if re_blendbackup.match(fo.suffix):
                    ct += 1
                    print(fo)
                    if not test:
                        fo.unlink()

    else:
        for f in os.listdir(fp):
            fo = Path(fp) / f
            if re_blendbackup.match(fo.suffix):
                ct += 1
                print(fo)
                if not test:
                    fo.unlink()

    if ct:
        print('INFO', f'Deleted {ct} file(s)')

kill_blend_backup_version(info['folderpath'], recursive = info['recursive'], test = info['test'])